#ifndef	_HASH_H
#	define	_HASH_H


// Hashable Objects should provide a "HashCode" and an "IsEqual" function

class	HashableObject
	{
	public:
		virtual	int		HashCode(int	Max)		=	0;
		virtual	bool	IsEqual(HashableObject*)	=	0;
	};


class	HashedObject
	{
	public:
		HashableObject	*Object;
		HashedObject	*Next;

						HashedObject ();
						~HashedObject ();
		void			Connect(HashableObject	*theObject=NULL) { Object = theObject; Next = NULL; };
		HashedObject	*Chain(HashedObject*);
	};

class	HashTable
	{
	public:
		HashedObject	**theHashTable;
		int				HashTableSize;
		bool			DeleteObjects;
		int				CurrentIndex;
		HashedObject	*CurrentSubIndex;
		int				Valid;

			HashTable(int	theSize, bool	DeleteOnEnd);
			~HashTable();

		bool			InsertObject(HashableObject	*);
		bool			RemoveObject(HashableObject	*);
		HashableObject	*LocateObject(HashableObject	*);

		bool			StartIterator();
		HashableObject	*Next();
		int				GetSize() { return(Valid); }
	};

#endif

