#	include	"Standard.h"


DEFINE_ALLOCATOR(Tuple);


bool
TupleSpace	::	StartSubSpace(
	char	*Name)
	{
	Tuple	*t = NEW(Tuple);

	t->Set(Name);
	SubSpaces.Push(t);
	return(true);
	}

bool
TupleSpace	::	EndSubSpace()
	{
	Tuple	*t;

	SubSpaces.Pop(t);
	DELETE(Tuple, t);
	return(true);
	}

bool
TupleSpace	::	BuildFullName(
	char	*Name,
	char	*Output)
	{
	Output[0] = '\0';
	if ( strchr(Name, '.' ) ) // Explicit paths are considered ``full''
		{
		strcpy(Output, Name);
		return(true);
		}
	int	Index = 0;
	while ( Index < SubSpaces.GetSize() )
		{
		Tuple	*t = SubSpaces[Index];
		if(strcmp(t->GetString(), "NoName"))	// "NoName" will be clapsed and folded away
			{
			strcat(Output, t->GetString());
			strcat(Output, ".");
			}
		++Index;
		}
	strcat(Output, Name);
	return(true);
	}

char	*
TupleSpace	::	CurrentSpace(
	char	*Output)
	{
	int	Index = 0;
	Output[0] = '\0';
	while ( Index < (SubSpaces.GetSize() - 1) )
		{
		Tuple	*t = SubSpaces[Index];
		if(strcmp(t->GetString(), "NoName"))	// "NoName" will be clapsed and folded away
			{
			strcat(Output, t->GetString());
			strcat(Output, ".");
			}
		++Index;
		}
	if ( !strcmp(SubSpaces[Index]->GetString() , "NoName"))
		{
		if ( Output )
			Output[strlen(Output)-1] = '\0';
		else
			strcat(Output, "NoName");
		}
	else
		strcat(Output, SubSpaces[Index]->GetString());
	return(Output);
	}

Tuple	*
TupleSpace	::	LocateCloseMatch(
	char	*name)
	{
	int		Index = 0;

	while ( Index < TupleList.GetSize() )
		{
		if(strstr(TupleList[Index]->GetName(), name))
			return(TupleList[Index]);
		++Index;
		}
	return(NULL);
	}

#	define	MakeBindFunction(ttt, fff)	\
bool \
TupleSpace	::	Bind(ttt	*Value, char	*name, char	*Default0, ttt	Default1)\
	{\
	if(Value)\
		{\
		char	s[1024];\
		BuildFullName(name, s);\
		Tuple	*t = NEW(Tuple);\
		t->SetName(s);\
		Tuple	*t2 = (Tuple*)theTupleSpace.LocateObject(t);\
		DELETE(Tuple, t);\
		if(!t2)\
			{\
			(*Value) = Default1;\
			if (Default0)\
				{\
				Tuple	*t3 = LocateCloseMatch(Default0);\
				if(t3)\
					(*Value) = t3->fff();\
				}\
			return(true);\
			}\
		if(!t2->GetTouched())\
			{\
			if (Default0)\
				{\
				Tuple	*t3 = LocateCloseMatch(Default0);\
				if(t3)\
				if(t3->GetTouched())\
					{\
					t2->Set(t3);\
					}\
				}\
			}\
		(*Value) = t2->fff();\
		return(true);\
		}\
	else\
		{\
		char	s[1024];\
		\
		if ( strchr(name, '.') )\
			return(true);\
			\
		BuildFullName(name, s);\
		Tuple	*t = NEW(Tuple);\
		t->SetName(s);\
		\
		if ( theTupleSpace.LocateObject(t) )\
			{\
			Warning("Inserting a duplicating tuple");\
			printf("Tuple is %s\n", name);\
			DELETE(Tuple, t);\
			return(true);\
			}\
		if ( Default0 )\
			{\
			Tuple	*t2 = LocateCloseMatch(Default0);\
		\
			if ( t2 )\
				t->Set(t2);\
			else\
				t->Set(Default1);\
			}\
		else\
			t->Set(Default1);\
		\
		theTupleSpace.InsertObject(t);\
		TupleList.Add(t);\
		}\
	return(true);\
	}

MakeBindFunction(int, GetInteger);
MakeBindFunction(uint64, GetuInt64);
MakeBindFunction(bool, GetBool);
MakeBindFunction(char *, GetString);

CommandLineArgument	*
TupleSpace	::	GetCommandLineArguments()
	{
	int					claSize = TupleList.GetSize();
	CommandLineArgument	*cla = new CommandLineArgument[claSize+1];

	memset(cla, 0, sizeof(CommandLineArgument)*(claSize+1));

	for(int	Index = 0;Index < claSize; Index++)
		{
		Tuple	*t = TupleList[Index];

		cla[Index].Name = t->GetName();
		cla[Index].theType= t->GetType();
		cla[Index].Ptr = t->GetPtr();
		cla[Index].SetOrDefault = &t->Touched;
		}
	return(cla);
	}

