
typedef	float	Float;
#	define	FloatZero	0.0
#	define	FloatOne	1.0

typedef	struct	_Color
	{
	byte	r;
	byte	g;
	byte	b;
	byte	z;
	}	Color;

const	Color	Black	=	{0,0,0,0};
const	Color	White	=	{255,255,255,0};

typedef	struct	_Vertex
	{
	Float	x;
	Float	y;
	Float	z;
	Color	color;
	}	Vertex;

typedef	Float	Matrix4x4[4][4];
typedef	Float	Vector4[4];

typedef	struct	_Polygon
	{
	Vertex	v1;
	Vertex	v2;
	Vertex	v3;
	Vector4	n;
	}	Polygon;


// mapping
#	define	VertexToVector4(vv, v4)	\
	v4[0] = vv.x;	\
	v4[1] = vv.y;	\
	v4[2] = vv.z;	\
	v4[3] = FloatOne;

#	define	Vector4ToVertex(v4, vv)	\
	vv.x = v4[0];	\
	vv.y = v4[1];	\
	vv.z = v4[2];

#	define	SwapVertexs(aa,bb)	\
	{Vertex	t = aa; aa = bb; bb = t; }

#	define	SwapFloats(aa,bb)	\
	{Float	t = aa; aa = bb; bb = t; }

