
class	ZBuffer
	{
	public:
		Color	*Pixels;
		int		Width, Height;

			ZBuffer(int	aWidth, int aHeight)
			{
			Width = aWidth;
			Height = aHeight;
			Pixels = new Color[Width*Height];
			};
			~ZBuffer()
				{
				delete Pixels;
				}
		bool	SetPixel(int x, int y, Color c)
			{
			if ( x < 0 )		return(false);
			if ( x >= Width )	return(false);
			if ( y < 0 )		return(false);
			if ( y >= Height )	return(false);

			Pixels[y*Width + x] = c;
			return(true);
			}
		bool	BlendPixel(int	rawIndex, Color		c)
			{
			if ( rawIndex < 0 )				return(false);
			if ( rawIndex >= Width*Height)	return(false);	

			if ( ((Pixels[rawIndex].z >= c.z) && (Pixels[rawIndex].z -  c.z) <= 1) ||
				 ((c.z >= Pixels[rawIndex].z) && (c.z - Pixels[rawIndex].z) <= 1) )
				{
				Pixels[rawIndex].r = (Pixels[rawIndex].r + c.r)/2;
				Pixels[rawIndex].g = (Pixels[rawIndex].g + c.g)/2;
				Pixels[rawIndex].b = (Pixels[rawIndex].b + c.b)/2;
				Pixels[rawIndex] = c;
				}
			else
			if ( Pixels[rawIndex].z < c.z )
				return (true);	// farther back
			else
				Pixels[rawIndex] = c;
			return(true);
			}
		bool	BlendPixel(int	x, int	y, Color	c)
			{
			if ( x < 0 )		return(false);
			if ( x >= Width )	return(false);
			if ( y < 0 )		return(false);
			if ( y >= Height )	return(false);

			return(BlendPixel(y*Width+x, c));
			}
		Color	GetPixel(int x, int y)
			{
			if ( x < 0 )		return(Pixels[0]);
			if ( x >= Width )	return(Pixels[0]);
			if ( y < 0 )		return(Pixels[0]);
			if ( y >= Height )	return(Pixels[0]);

			return(Pixels[y*Width + x]);
			}

		bool	Reset()
			{
			Color	ResetPixel	=	{	0, 0, 0, 255	};	// black, farthest away

			for(int	y=0; y<Height; y++)
				for(int x=0; x<Width; x++)
					SetPixel(x,y, ResetPixel);

			return(true);
			}

		bool	Dump(char	*filename)
			{
			FILE	*fp = fopen(filename, "wb");

			if(!fp)	return(false);

			char	s[1024];
			sprintf(s, "P6\n%d %d 255\n", Width, Height);
			fwrite(s, 1, strlen(s), fp);
			// lame, but just fwrite each pixel
			for(int	y=0; y<Height; y++)
				for(int x=0; x<Width; x++)
					{
					fwrite(&Pixels[y*Width+x].r, 1, 1, fp);
					fwrite(&Pixels[y*Width+x].g, 1, 1, fp);
					fwrite(&Pixels[y*Width+x].b, 1, 1, fp);

					// useful for debugging sometimes
					//fwrite(&Pixels[y*Width+x].z, 1, 1, fp);
					//fwrite(&Pixels[y*Width+x].z, 1, 1, fp);
					//fwrite(&Pixels[y*Width+x].z, 1, 1, fp);
					}
			fclose(fp);
			return(true);	
			}
	};
